#pragma once
#include <apps/Common/exampleHelper.h>
#include <mvIMPACT_CPP/mvIMPACT_acquire.h>
#include <mvDisplay/Include/mvIMPACT_acquire_display.h>
#include <common/minmax.h>
#include <mvIMPACT_CPP/mvIMPACT_acquire_GenICam.h>

#include <stdio.h>
#include <windows.h>
#include <process.h>

#include <iostream>
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/cvconfig.h"
#include <opencv2/opencv.hpp>
#include <cmath>
#include <opencv2/stitching/detail/matchers.hpp>
#include "opencv2/highgui.hpp"
#include "opencv2\features2d\features2d.hpp"

using namespace std;
using namespace mvIMPACT::acquire;
using namespace mvIMPACT::acquire::display;
using namespace cv;
using namespace cv::detail;

double fps = 4.0;

bool USE_DISPLAY = true;

struct buffer {
	vector<Mat> img, full_images;
	vector<bool> ready_for_pano;
	bool threads_interrupt;
	Mat panorama_final;
	Mat panorama_seq;

	Mat Hevc8k;
	vector<std::string> camnumb;
	unsigned int numDev;

}buffstack;

void DesktopResolution(int& horizontal)
{
	RECT desktop;
	// Get a handle to the desktop window
	const HWND hDesktop = GetDesktopWindow();
	// Get the size of screen to the variable desktop
	GetWindowRect(hDesktop, &desktop);
	// The top left corner will have coordinates (0,0)
	// and the bottom right corner will have coordinates
	// (horizontal, vertical)
	horizontal = desktop.right;

}



double stredniHodnotaMatice(Mat matice) {
	double stredniHodnota = 0;
	for (int x = 0; x < matice.rows; x++) {
		for (int y = 0; y < matice.cols; y++) {

			stredniHodnota = stredniHodnota + (double)matice.at<uchar>(x, y);

		}
	}
	stredniHodnota = stredniHodnota / (matice.rows * matice.cols);

	return stredniHodnota;
}

//Normalizovan odchyblka obrazu
double normalizovanaOdchylka(Mat matice) {
	double normalizovanaOdchylka = 0;
	double strednihodnota = stredniHodnotaMatice(matice);

	for (int x = 0; x < matice.rows; x++) {
		for (int y = 0; y < matice.cols; y++) {

			normalizovanaOdchylka = normalizovanaOdchylka + pow(abs((double)matice.at<uchar>(x, y) - strednihodnota), 2);
		}
	}
	normalizovanaOdchylka = normalizovanaOdchylka / (matice.rows*matice.cols*strednihodnota);

	return normalizovanaOdchylka;
}

double sirkaHistogramu(Mat matice) {
	double hodnotaMin = 255, hodnotaMax = 0;

	for (int x = 0; x < matice.rows; x++) {
		for (int y = 0; y < matice.cols; y++) {
			if ((double)matice.at<uchar>(x, y) < hodnotaMin)
				hodnotaMin = (double)matice.at<uchar>(x, y);
			if ((double)matice.at<uchar>(x, y) > hodnotaMax)
				hodnotaMax = (double)matice.at<uchar>(x, y);

		}
	}
	return hodnotaMax - hodnotaMin;
}

double detektorHran_I(Mat matice) {
	Mat tempmatice;

	Laplacian(matice, tempmatice, CV_64F, 1);

	double koeficientOstrosti = 0;

	for (int x = 0; x < tempmatice.rows; x++) {
		for (int y = 0; y < tempmatice.cols; y++) {

			koeficientOstrosti = koeficientOstrosti + pow(tempmatice.at<double>(x, y), 2);

		}
	}
	return koeficientOstrosti;
}
