#ifdef _MSC_VER // is Microsoft compiler?
#   if _MSC_VER < 1300  // is 'old' VC 6 compiler?
#       pragma warning( disable : 4786 ) // 'identifier was truncated to '255' characters in the debug information'
#   endif // #if _MSC_VER < 1300
#endif // #ifdef _MSC_VER

#include "Funkce.h"

unsigned int devCnt;

int desktop_horizontal;

bool ulozeni_img = false;
bool nalezeni_obrazce = false;
bool nalezeni_mista_ostreni = false;
bool mereni_ostrosti = false;
bool reset_ostrosti = false;
bool info_kamera = false;

double get_gainCam, get_exposTime, get_balancWhite;

//Promena koeficientu ostrosti
double MAX_Koeficient_ostrosti = INT_MIN;
double MIN_Koeficient_ostrosti = INT_MAX;
double temp_suma_koeficient_otrosti = 0;
int pocitadlo_sumy_KO = 0;
double Aktualni_Ostrost = 0;

vector<Point2f> transf_corners(4);

//tverec pro vpoet ostrosti
Point2f stredovy_bod(0.0, 0.0);
Rect vyrez;
Mat Ostrici_ctverec_img;
double sirka_zony_ostreni = 120, vyska_zony_ostreni = 120;

Mat ostridlo = imread("obr/ostridlo2.jpg");
Mat openCVImage_vykreslovaci;

//-----------------------------------------------------------------------------
/// zskn bezpenho pstupu k podprocesu a zobrazovacmu modulu
class CriticalSection
	//-----------------------------------------------------------------------------
{
	CRITICAL_SECTION m_criticalSection;
public:
	CriticalSection()
	{
		InitializeCriticalSection(&m_criticalSection);
	}
	~CriticalSection()
	{
		DeleteCriticalSection(&m_criticalSection);
	}
	void lock(void)
	{
		EnterCriticalSection(&m_criticalSection);
	}
	void unlock(void)
	{
		LeaveCriticalSection(&m_criticalSection);
	}
} g_critSect;

//-----------------------------------------------------------------------------
class LockedScope
	//-----------------------------------------------------------------------------
{
	CriticalSection&    m_l;
	LockedScope(const LockedScope&);             
	LockedScope& operator=(const LockedScope&); 
public:
	explicit LockedScope(CriticalSection& l) : m_l(l)
	{
		m_l.lock();
	}
	~LockedScope()
	{
		m_l.unlock();
	}
};

//-----------------------------------------------------------------------------
///parametry vlkna
class ThreadParameter
	//-----------------------------------------------------------------------------
{
	Device*             m_pDev;
	volatile bool       m_boTerminateThread;
public:
	Mat cam_buffer;
	explicit ThreadParameter(Device* pDev) : m_pDev(pDev), m_boTerminateThread(false) {}
	Device* device(void) const
	{
		return m_pDev;
	}
	/*ImageDisplayWindow& displayWindow( void )
	{
	return m_displayWindow;
	}*/
	bool terminated(void) const
	{
		return m_boTerminateThread;
	}
	void terminateThread(void)
	{
		m_boTerminateThread = true;
	}
	void resuscitateThread(void)
	{
		m_boTerminateThread = false;
	}
};
//vyrovnvac pam
class UserSuppliedHeapBuffer
	//-----------------------------------------------------------------------------
{
	char* pBuf_;
	int bufSize_;
	int alignment_;
	int pitch_;
public:
	explicit UserSuppliedHeapBuffer(int bufSize, int alignment, int pitch) : pBuf_(0), bufSize_(bufSize), alignment_(alignment), pitch_(pitch)
	{
		if (bufSize_ > 0)
		{
			pBuf_ = new char[bufSize_ + alignment_];
		}
	}
	~UserSuppliedHeapBuffer()
	{
		delete[] pBuf_;
	}
	char* getPtr(void)
	{
		if (alignment_ <= 1)
		{
			return pBuf_;
		}
		return reinterpret_cast<char*>(align(reinterpret_cast<UINT_PTR>(pBuf_), static_cast<UINT_PTR>(alignment_)));
	}
	int getSize(void) const
	{
		return bufSize_;
	}
};

typedef std::vector<UserSuppliedHeapBuffer*> CaptureBufferContainer;

struct CaptureParameter
	//-----------------------------------------------------------------------------
{
	Device*                 pDev;
#ifdef USE_DISPLAY
	ImageDisplayWindow*     pDisplayWindow;
#endif // #ifdef USE_DISPLAY
	//#ifdef BUILD_WITH_OPENCV_SUPPORT
	std::string             openCVDisplayTitle;
	std::string             openCVResultDisplayTitle;
	//#endif // #ifdef BUILD_WITH_OPENCV_SUPPORT
	FunctionInterface       fi;
	ImageRequestControl     irc;
	Statistics              statistics;
	bool                    boUserSuppliedMemoryUsed;
	bool                    boAlwaysUseNewUserSuppliedBuffers;
	int                     bufferSize;
	int                     bufferAlignment;
	int                     bufferPitch;
	CaptureBufferContainer  buffers;
	CaptureParameter(Device* p) : pDev(p), fi(p), irc(p), statistics(p), boUserSuppliedMemoryUsed(false),
		boAlwaysUseNewUserSuppliedBuffers(false), bufferSize(0), bufferAlignment(0), bufferPitch(0), buffers()
	{

		openCVDisplayTitle = string("mvIMPACT_acquire sample, Device " + pDev->serial.read() + ", OpenCV display");
		openCVResultDisplayTitle = openCVDisplayTitle + "(Result)";

	}
	~CaptureParameter()
	{
#ifdef USE_DISPLAY
		delete pDisplayWindow;
#endif // #ifdef USE_DISPLAY
	}
};

void saveImages(CaptureParameter* pCaptureParameter, ThreadParameter* pThreadParameter, Request* pRequest, Device* pDev)
//-----------------------------------------------------------------------------
{

label_start:

	int openCVDataType = CV_8UC1;
	switch (pRequest->imagePixelFormat.read())
	{
	case ibpfMono8:
		openCVDataType = CV_8UC1;
		break;
	case ibpfMono10:
	case ibpfMono12:
	case ibpfMono14:
	case ibpfMono16:
		openCVDataType = CV_16UC1;
		break;
	case ibpfMono32:
		openCVDataType = CV_32SC1;
		break;
	case ibpfBGR888Packed:
	case ibpfRGB888Packed:
		openCVDataType = CV_8UC3;//nastaveno na 24bit
		break;
	case ibpfRGBx888Packed:
		openCVDataType = CV_8UC4;
		break;
	case ibpfRGB101010Packed:
	case ibpfRGB121212Packed:
	case ibpfRGB141414Packed:
	case ibpfRGB161616Packed:
		openCVDataType = CV_16UC3;
		break;
	case ibpfMono12Packed_V1:
	case ibpfMono12Packed_V2:
	case ibpfBGR101010Packed_V2:
	case ibpfRGB888Planar:
	case ibpfRGBx888Planar:
	case ibpfYUV422Packed:
	case ibpfYUV422_10Packed:
	case ibpfYUV422_UYVYPacked:
	case ibpfYUV422_UYVY_10Packed:
	case ibpfYUV422Planar:
	case ibpfYUV444Packed:
	case ibpfYUV444_10Packed:
	case ibpfYUV444_UYVPacked:
	case ibpfYUV444_UYV_10Packed:
	case ibpfYUV444Planar:
	case ibpfYUV411_UYYVYY_Packed:
		cout << "ERROR! Tento pixelovy format nelze vykreslit (" << pRequest->imagePixelFormat.readS() << ") v OpenCV! Vyberte jin nap. mvIMPACT::acquire::ImageDestination::pixelFormat!" << endl;
		exit(42);
		break;
	}


	Mat openCVImage(cv::Size(pRequest->imageWidth.read(), pRequest->imageHeight.read()), openCVDataType, pRequest->imageData.read(), pRequest->imageLinePitch.read());

	openCVImage.copyTo(openCVImage_vykreslovaci);

	if (stredovy_bod != Point2f(0.0, 0.0)) {
		//oznaen nalezenho obrazce nebo oznaen msta ve stedu obrazovky, ve kterm se bude hledat nejvhodnj sektor
		line(openCVImage_vykreslovaci, transf_corners[0], transf_corners[1], Scalar(0, 0, 255), 8);
		line(openCVImage_vykreslovaci, transf_corners[1], transf_corners[2], Scalar(0, 0, 255), 8);
		line(openCVImage_vykreslovaci, transf_corners[2], transf_corners[3], Scalar(0, 0, 255), 8);
		line(openCVImage_vykreslovaci, transf_corners[3], transf_corners[0], Scalar(0, 0, 255), 8);

		//Oznaen msta na kter se ost
		rectangle(openCVImage_vykreslovaci, stredovy_bod - Point2f(sirka_zony_ostreni/2, vyska_zony_ostreni/2), 
											stredovy_bod + Point2f(sirka_zony_ostreni/2, vyska_zony_ostreni/2), Scalar(255, 0, 0), 8, 8, 0);

	}
	
	
	if (mereni_ostrosti && stredovy_bod != Point2f(0.0, 0.0)) {
		/*******  Pole s vpisem hodnoty ostrosti  *****************************************/
		rectangle(openCVImage_vykreslovaci, Point2f((openCVImage_vykreslovaci.cols) - 1000, (openCVImage_vykreslovaci.rows) - 100), 
											Point2f((openCVImage_vykreslovaci.cols), (openCVImage_vykreslovaci.rows)), 
											Scalar(255, 255, 255), -1, CV_AA);
		/*******  Text s hodnoto zaosten   ***********************************************/
		putText(openCVImage_vykreslovaci, "Ostrost: " + to_string((int)(Aktualni_Ostrost)) + "%",
											Point2f((openCVImage_vykreslovaci.cols) - 1000, openCVImage_vykreslovaci.rows - 5), 
											CV_FONT_HERSHEY_TRIPLEX, 4.0, Scalar(0, 0, 0), 4);
	}
	
	medianBlur(openCVImage, openCVImage, CV_32F);
	medianBlur(openCVImage_vykreslovaci, openCVImage_vykreslovaci, CV_32F);

	namedWindow("OpenCV " + pDev->serial.read(), CV_WINDOW_NORMAL);
	imshow("OpenCV " + pDev->serial.read(), openCVImage_vykreslovaci);
	waitKey(1);


	for (int i = 0; i < buffstack.numDev; i++)
	{

		if (pDev->serial.read() == buffstack.camnumb[i])
		{
			if (ulozeni_img)
			{
				imwrite("Ulozene_obrazky/snimek" + pRequest->infoFrameID.readS() + ".bmp", openCVImage);

				cout << "Snimek " << pRequest->infoFrameID.readS() << " byl ulozen." << endl;
				ulozeni_img = false;

			}
			//**********************************************************************************************
			if (reset_ostrosti) {
				MAX_Koeficient_ostrosti = INT_MIN;
				MIN_Koeficient_ostrosti = INT_MAX;
				temp_suma_koeficient_otrosti = 0;
				pocitadlo_sumy_KO = 0;
				Aktualni_Ostrost = 0;
				stredovy_bod = Point2f(0.0, 0.0);

				reset_ostrosti = false;
				mereni_ostrosti = false;
				

			}

			//**********************************************************************************************
			if (nalezeni_obrazce) {

				vector<ImageFeatures> features(2);
				cv::Ptr<FeaturesFinder> finder;
				//::::::::::::  nalezen dleitch bod v obraze  ::::::::::
				finder = makePtr<SurfFeaturesFinder>();
				//finder = makePtr<OrbFeaturesFinder>();

				(*finder)(openCVImage, features[0]);
				features[0].img_idx = 0;
				(*finder)(ostridlo, features[1]);
				features[1].img_idx = 1;

				finder->collectGarbage();

				vector<MatchesInfo> pairwise_matches;
				Ptr<FeaturesMatcher> matcher;
				//nalezen nejlepch spolench bod
				matcher = makePtr<AffineBestOf2NearestMatcher>(false, false, 0.3f);

				(*matcher)(features, pairwise_matches);

				matcher->collectGarbage();

				Mat H = pairwise_matches[2].H;

				if (H.dims == 0) {
					cout << "Ostrici obrazec nebyl nalezen!" << endl;
					nalezeni_obrazce = false;
					continue;
				}

				vector<Point2f> obj_corners(4);

				obj_corners[0] = cvPoint(0, 0); obj_corners[1] = cvPoint(ostridlo.cols, 0);
				obj_corners[2] = cvPoint(ostridlo.cols, ostridlo.rows); obj_corners[3] = cvPoint(0, ostridlo.rows);

				perspectiveTransform(obj_corners, transf_corners, H);

				stredovy_bod.x = (transf_corners[0].x + transf_corners[1].x + transf_corners[2].x +transf_corners[3].x) / 4;
				stredovy_bod.y = (transf_corners[0].y + transf_corners[1].y + transf_corners[2].y +transf_corners[3].y) / 4;

				vyrez = Rect(stredovy_bod.x - sirka_zony_ostreni/2, stredovy_bod.y - vyska_zony_ostreni/2, sirka_zony_ostreni, vyska_zony_ostreni);

				nalezeni_obrazce = false;

			}

			//****  Vpoet aktulnho zaosten  ****************************************************
			if (mereni_ostrosti) {
				if (stredovy_bod == Point2f(0.0, 0.0)) {
					cout << "Neni nalezene misto ostreni!!!" << endl;
					mereni_ostrosti = false;
					continue;
				}
				Ostrici_ctverec_img = openCVImage(vyrez);

				double temp_koef_ostrosti = detektorHran_I(Ostrici_ctverec_img);

				temp_suma_koeficient_otrosti += temp_koef_ostrosti;
				pocitadlo_sumy_KO++;


				if (pocitadlo_sumy_KO == 3) {
					temp_suma_koeficient_otrosti = temp_suma_koeficient_otrosti / pocitadlo_sumy_KO;
					
					if (MAX_Koeficient_ostrosti < temp_suma_koeficient_otrosti)
						MAX_Koeficient_ostrosti = temp_suma_koeficient_otrosti;

					if (MIN_Koeficient_ostrosti > temp_suma_koeficient_otrosti)
						MIN_Koeficient_ostrosti = temp_suma_koeficient_otrosti;

					Aktualni_Ostrost = ((temp_suma_koeficient_otrosti - MIN_Koeficient_ostrosti) / (MAX_Koeficient_ostrosti - MIN_Koeficient_ostrosti)) * 100;

				cout << "\n Zaostreni v procentech: " << Aktualni_Ostrost << "%";
					
				temp_suma_koeficient_otrosti = 0;
				pocitadlo_sumy_KO = 0;
				}

			}
			//****  Funkce pro hledn msta ostrosti   ***********************************************************
			if (nalezeni_mista_ostreni) {

				//definovan velikosti pole ve stedu obrazovky
				int sirka_mista_pro_ostrni = 500;
				int vyska_mista_pro_ostrni = 500;


				int pocet_vyrezu_hran = 0;
				
				Point2f bod_mista_pro_ostreni((openCVImage.cols / 2) - (sirka_mista_pro_ostrni / 2), 
											  (openCVImage.rows / 2) - (vyska_mista_pro_ostrni / 2));//lev horn hor

				transf_corners[0] = bod_mista_pro_ostreni;
				transf_corners[1] = Point2f(bod_mista_pro_ostreni.x + sirka_mista_pro_ostrni, bod_mista_pro_ostreni.y);
				transf_corners[2] = Point2f(bod_mista_pro_ostreni.x + sirka_mista_pro_ostrni, bod_mista_pro_ostreni.y+vyska_mista_pro_ostrni);
				transf_corners[3] = Point2f(bod_mista_pro_ostreni.x, bod_mista_pro_ostreni.y + vyska_mista_pro_ostrni);
				

				Mat tempIMG = openCVImage(Rect(bod_mista_pro_ostreni.x, bod_mista_pro_ostreni.y, 
											   sirka_mista_pro_ostrni, vyska_mista_pro_ostrni));

				cvtColor(tempIMG, tempIMG, CV_RGB2GRAY);

				Canny(tempIMG, tempIMG, 10, 100);

				int tempHodnotaHran = 0;
				int MAXHodnotaHran = 0;

				for (int i = 0; i < tempIMG.rows - sirka_zony_ostreni; i++) {
					for (int j = 0; j < tempIMG.cols - vyska_zony_ostreni; j++) {
					
						for (int x = 0; x < sirka_zony_ostreni; x++) {
							for (int y = 0; y < vyska_zony_ostreni; y++) {
								tempHodnotaHran = tempHodnotaHran + tempIMG.at<uchar>(j+x, i+y);
							}
						}

						if (MAXHodnotaHran < tempHodnotaHran) {
							pocet_vyrezu_hran++;
							MAXHodnotaHran = tempHodnotaHran;
							vyrez = Rect(i + bod_mista_pro_ostreni.x, j + bod_mista_pro_ostreni.y, sirka_zony_ostreni, vyska_zony_ostreni);
						}

						if (tempHodnotaHran != 0)
						tempHodnotaHran = 0;
					}
				
				}

				//imshow("Hrany", tempIMG);		
				
				stredovy_bod.x = vyrez.x + vyrez.width / 2;
				stredovy_bod.y = vyrez.y + vyrez.height / 2;

				if (pocet_vyrezu_hran == 0) {
					cout << endl << "Idealni misto pro ostreni nebylo nalezeno." << endl;
					cout << "Je spusteno ostreni na stred!" << endl;
					stredovy_bod.x = (transf_corners[0].x + transf_corners[1].x + transf_corners[2].x + transf_corners[3].x) / 4;
					stredovy_bod.y = (transf_corners[0].y + transf_corners[1].y + transf_corners[2].y + transf_corners[3].y) / 4;
					vyrez = Rect(stredovy_bod.x - sirka_zony_ostreni / 2,
						stredovy_bod.y - vyska_zony_ostreni / 2,
						sirka_zony_ostreni, vyska_zony_ostreni);
				}

				nalezeni_mista_ostreni = false;
			}
		}
	}
	//ovldn stickem klves
	if ((GetAsyncKeyState('S') & 0x8000)) //uloen obrzku
	{
		ulozeni_img = true;
	}

	if ((GetAsyncKeyState('O') & 0x8000)) //nalezen ostidla ve scn
	{
		nalezeni_obrazce = true;
	}

	if ((GetAsyncKeyState('M') & 0x8000)) //hledn nejlepho msta pro osten ve stedu obrazu
	{
		nalezeni_mista_ostreni = true;
	}

	if ((GetAsyncKeyState('K') & 0x8000)) //start/stop men ostrosti
	{
		if (mereni_ostrosti)
			mereni_ostrosti = false;
		else
			mereni_ostrosti = true;

	}

	if ((GetAsyncKeyState('R') & 0x8000)) //uveden programu od vchozho nastaven(reset)
	{
			reset_ostrosti = true;
	}

	if ((GetAsyncKeyState('I') & 0x8000)) //info o kamee
	{
		info_kamera = true;
	}
}

//nastaven zazen
void configureDevice(Device* pDev)
//-----------------------------------------------------------------------------
{
	GenICam::DeviceControl dc(pDev);

	//pokud se jedn o barevnou kameru pepne se formt na Bayer
	GenICam::ChunkDataControl cdc(pDev);
	cdc.chunkModeActive.write(bTrue);
	cdc.chunkSelector.writeS("Timestamp");
	cdc.chunkEnable.write(bTrue);

	ImageDestination id(pDev);



	GenICam::ImageFormatControl ifc(pDev);
	if ((dc.mvDeviceSensorColorMode.isValid()) && (dc.mvDeviceSensorColorMode.readS() == "BayerMosaic"))
	{
		if (ifc.pixelColorFilter.isValid())
		{
			const string parity = ifc.pixelColorFilter.readS();
			if (parity == "BayerBG")
			{
				ifc.pixelFormat.writeS("BayerBG8");
			}
			else if (parity == "BayerGB")
			{
				ifc.pixelFormat.writeS("BayerGB8");
			}
			else if (parity == "BayerRG")
			{
				//ifc.pixelFormat.writeS( "BayerRG10" );
				//ifc.pixelFormat.writeS( "BGR8" );
				ifc.pixelFormat.writeS("BayerRG8");
				id.pixelFormat.write(idpfRGB888Packed);


			}
			else if (parity == "BayerGR")
			{
				ifc.pixelFormat.writeS("BayerGR8");
			}
			else
			{
				cout << "Nedefinovani BayerMosaicParity! Ukonceni..." << endl;
				exit(42);
			}
		}
		else
		{
			cout << "Nelze urcit BayerMosaicParity! Ukonceni..." << endl;
			exit(42);
		}
	}

	cout << "Prenos pixeloveho formatu: " << ifc.pixelFormat.readS() << endl;

}
///vlkno
//-----------------------------------------------------------------------------
unsigned int __stdcall liveThread(void* pData)
//-----------------------------------------------------------------------------
{
	ThreadParameter* pThreadParameter = reinterpret_cast<ThreadParameter*>(pData);
	CaptureParameter* pCaptureParameter = reinterpret_cast<CaptureParameter*>(pData);
	unsigned int cnt = 0;
	Device* pDev = pThreadParameter->device();

	string serialNum_cam = pDev->serial.read();

	if (buffstack.threads_interrupt)//preruseni vlaken 
	{
		pThreadParameter->terminateThread();
	}

	if (!buffstack.threads_interrupt) { pThreadParameter->resuscitateThread(); }

	{
		LockedScope lockedScope(g_critSect);
		cout << "Zkousim otevrit " << pDev->serial.read() << endl;
	}

	try
	{
		// if this device offers the 'GenICam' interface switch it on, as this will
		// allow are better control over GenICam compliant devices
		conditionalSetProperty(pDev->interfaceLayout, dilGenICam);
		// if this device offers a user defined acquisition start/stop behaviour
		// enable it as this allows finer control about the streaming behaviour
		conditionalSetProperty(pDev->acquisitionStartStopBehaviour, assbUser);

		if (!(pDev->isOpen()))
		{
			pDev->open();
		}

	}
	catch (const ImpactAcquireException& e)
	{
		LockedScope lockedScope(g_critSect);
		// this e.g. might happen if the same device is already opened in another process...
		cout << "An error occurred while opening the device " << pDev->serial.read()
			<< "(error code: " << e.getErrorCode() << "(" << e.getErrorCodeAsString() << ")). Terminating thread." << endl
			<< "Press [ENTER] to end the application..."
			<< endl;
		return 0;
	}

	{
		LockedScope lockedScope(g_critSect);
		cout << "Opened " << pDev->serial.read() << endl;
	}

	//ImageDisplay& display = pThreadParameter->displayWindow().GetImageDisplay();
	// establish access to the statistic properties
	Statistics statistics(pDev);
	// create an interface to the device found
	FunctionInterface fi(pDev);

	// Send all requests to the capture queue. There can be more than 1 queue for some devices, but for this sample
	// we will work with the default capture queue. If a device supports more than one capture or result
	// queue, this will be stated in the manual. If nothing is mentioned about it, the device supports one
	// queue only. This loop will send all requests currently available to the driver. To modify the number of requests
	// use the property mvIMPACT::acquire::SystemSettings::requestCount at runtime or the property
	// mvIMPACT::acquire::Device::defaultRequestCount BEFORE opening the device.
	TDMR_ERROR result = DMR_NO_ERROR;
	while ((result = static_cast<TDMR_ERROR>(fi.imageRequestSingle())) == DMR_NO_ERROR) {};
	if (result != DEV_NO_FREE_REQUEST_AVAILABLE)
	{
		LockedScope lockedScope(g_critSect);
		cout << "'FunctionInterface.imageRequestSingle' returned with an unexpected result: " << result
			<< "(" << ImpactAcquireException::getErrorCodeAsString(result) << ")" << endl;
	}





	manuallyStartAcquisitionIfNeeded(pDev, fi);
	// bh smyky vlkna
	Request* pRequest = 0;
	vector<string> list;
	const unsigned int timeout_ms = 500;
	int requestNr = INVALID_ID;
	

	// we always have to keep at least 2 images as the display module might want to repaint the image, thus we
	// can't free it unless we have a assigned the display to a new buffer.
	int lastRequestNr = INVALID_ID;


	GenICam::AcquisitionControl ac(pDev);
	GenICam::AnalogControl anac(pDev);
	GenICam::DeviceControl dc(pDev);
	GenICam::ChunkDataControl cdc(pDev);

	cout << "Preruseni...." << endl;

ThreadStart:
	while (!pThreadParameter->terminated())
	{
		if (buffstack.threads_interrupt)
		{
			pThreadParameter->terminateThread();
		}

		++cnt;
		//automaticke vyvazeni barev obrazu
		if (mereni_ostrosti == false) {
			ac.exposureAuto.writeS("Continuous");
			get_exposTime = ac.exposureTime.read();	

			anac.gainAuto.writeS("Continuous");
			get_gainCam = anac.gain.read();

			anac.balanceWhiteAuto.writeS("Continuous");
			get_balancWhite = anac.balanceWhiteAuto.read();

			
		}//pi zapnut men se automatick pravy obrazu zastav
		else {
			ac.exposureAuto.writeS("Off");
			ac.exposureTime.write(get_exposTime);
			anac.gainAuto.writeS("Off");
			anac.gain.write(get_gainCam);
			anac.balanceWhiteAuto.writeS("Off");
			anac.balanceWhiteAuto.write(get_balancWhite);
		}

		ac.acquisitionFrameRate.write(fps);

		// pokejte na vsledky z vchoz fronty snmn
		requestNr = fi.imageRequestWaitFor(timeout_ms);
		if (fi.isRequestNrValid(requestNr))

		{
			pRequest = fi.getRequest(requestNr);
			if ((pRequest->isOK()) && ((pRequest->infoFrameNr.read())>0))
			{

				if (info_kamera)
				{
					LockedScope lockedScope(g_critSect);
					cout << "Info from " << pDev->serial.read() << endl
						<< ": " << statistics.framesPerSecond.name() << ": " << statistics.framesPerSecond.readS()
						<< ", " << statistics.errorCount.name() << ": " << statistics.errorCount.readS()
						<< ", " << statistics.bandwidthConsumed.name() << ": " << statistics.bandwidthConsumed.read() << " kB/s"
						<< ", " << pRequest->infoTimeStamp_us.name() << ": " << pRequest->infoTimeStamp_us.readS()
						<< ", " << pRequest->imagePixelFormat.name() << ": " << pRequest->imagePixelFormat.readS()
						<< ", " << dc.deviceTemperature.name() << ": " << dc.deviceTemperature.readS()
						<< ", " << pRequest->infoFrameID.name() << ": " << pRequest->infoFrameID.readS()
						<< ", " << pRequest->chunkTimestamp.name() << ": " << pRequest->chunkTimestamp.read()
						<< ", " << ac.exposureTime.name() << ": " << ac.exposureTime.readS()

						<< ", " << anac.gain.name() << ": " << anac.gain.readS() << endl << endl;

					info_kamera = false;
				}


				saveImages(pCaptureParameter, pThreadParameter, pRequest, pDev);



			}
			else
			{
				LockedScope lockedScope(g_critSect);
				cout << "Error: " << pRequest->requestResult.readS() << endl;
			}
			if (fi.isRequestNrValid(lastRequestNr))
			{
				// tento obrzek byl zobrazen, take vyrovnvac pam ji nen potebn ...
				fi.imageRequestUnlock(lastRequestNr);
			}
			lastRequestNr = requestNr;
			// odeslat nov poadavek na obrzek do fronty
			fi.imageRequestSingle();
		}
		else
		{
			LockedScope lockedScope(g_critSect);
			// If the error code is -2119(DEV_WAIT_FOR_REQUEST_FAILED), the documentation will provide
			// additional information under TDMR_ERROR in the interface reference (
			cout << "imageRequestWaitFor failed (" << requestNr << ", " << ImpactAcquireException::getErrorCodeAsString(requestNr) << ", device " << pDev->serial.read() << ")"
				<< ", timeout value too small?" << endl;
		}
	}


	while (pThreadParameter->terminated())

	{
		if (!buffstack.threads_interrupt)
		{
			pThreadParameter->resuscitateThread();
			goto ThreadStart;
		}

	}

	manuallyStopAcquisitionIfNeeded(pDev, fi);

	// uvolnit posledn potenciln zamknut poadavek
	if (fi.isRequestNrValid(requestNr))
	{
		fi.imageRequestUnlock(requestNr);
	}
	// smazn vech front
	fi.imageRequestReset(0, 0);


	return 0;
}

//-----------------------------------------------------------------------------
int main(int argc, char* argv[])
//-----------------------------------------------------------------------------
{
	DeviceManager devMgr;
	devCnt = devMgr.deviceCount();
	buffstack.numDev = devCnt;

	DesktopResolution(desktop_horizontal);


	if (devCnt == 0)
	{
		cout << "Kamera nebyla nalezena, program bude ukonen!" << endl;
		return 0;
	}

	string productFilter("*");

		cout << " Prikazove klavesy:" << endl
			 << " 'O' ... Nalezeni definovaneho Obrazce" << endl
			 << " 'M' ... Nalezeni nejlepsiho Mista pro ostreni ve stredu obrazovky" << endl
			 << " 'K' ... Zapnuti/Vypnuti mereni Koeficientu ostrosti" << endl
			 << " 'R' ... Reset programu" << endl
			 << " 'I' ... Informace" << endl << endl;

	

	std::vector<ThreadParameter*> threadParams;

	buffstack.ready_for_pano.resize(devCnt);
	buffstack.full_images.resize(devCnt);
	buffstack.img.resize(devCnt);
	buffstack.threads_interrupt = false;

	for (unsigned int i = 0; i < devCnt; i++)
	{
		if (match(devMgr[i]->product.read(), productFilter, '*') == 0)
		{
			threadParams.push_back(new ThreadParameter(devMgr[i]));
			cout << "Kamera:" <<devMgr[i]->family.read() << " (" << devMgr[i]->serial.read() << ")" << endl;
		}
	}


	buffstack.camnumb.resize(devCnt);
	buffstack.camnumb[0] = "F2300910"; //slo kamery
									   //buffstack.camnumb[0] = "FF002946";


	if (threadParams.empty())
	{
		cout << "Nebylo nalezeno zadne zarizeni MATRIX VISION! Nelze pokraovat." << endl;
		return 0;
	}

	size_t vSize = threadParams.size();
	HANDLE* pHandles = new HANDLE[vSize];


	//start vlkna
	for (unsigned int j = 0; j < vSize; j++)
	{
		configureDevice(threadParams[j]->device());

		unsigned int dwThreadID;
		pHandles[j] = (HANDLE)_beginthreadex(0, 0, liveThread, (LPVOID)threadParams[j], 0, &dwThreadID);
	}

	// Vlkna zanou bet
	{
		LockedScope lockedScope(g_critSect);
	}
	getchar();

	// zastaven vlken
	{
		LockedScope lockedScope(g_critSect);
	}

	return 0;
}